classdef Mbar < handle                % topo is a subclass of handle
    properties
        visible 
        hbar 
        htit 
        ptch 
        pw
        tval
    end % properties 

    properties (Dependent = true)        % Do not store the Data property 
        Data
        Dt = [];      
    end % properties Dependent = true
    
    methods
       
        function mb = Mbar(ivisible, varargin)
           
            mb.visible = ivisible;
    
            if (mb.visible == 0)
                return;
            end

            mb.hbar = waitbar(0, 'Please wait...');
    
            if (nargin >= 2)
                title = varargin{1};
                set(mb.hbar, 'Name', title);
            end

            ch = get(mb.hbar, 'Children');
            mb.htit = get(ch, 'Title');
            mb.ptch = findobj(ch, 'Type', 'patch');
    
            if (nargin == 3)
                mb.pw = varargin{2};
            end
            drawnow;
            
        end
        
        function [ret] = Bname(o1, name, varargin)
            
            ret = 1;
    
            if (o1.visible == 0)
                return;
            end

            o2 = o1;
            if ishandle(o2.hbar)
                name = strrep(name, '\', '\\');
                name = strrep(name, '_', '\_');
                set(o2.htit, 'String', name);
                if (nargin == 3)
                    o2.pw = varargin{1};
                end
                o2.Bval(0);
                drawnow;
                %         tval = 0;
%         xt1 = [0 100 100 0]';
%         set(ptch, 'XData', xt1, 'FaceColor', [1 1 1], 'EdgeColor', [0 0 0]);
            else
                ret = -1;
            end
            
        end
        
        function [ret] = Bpow(o1, ipw)

            o2 = o1;
            ret = 1;
            o2.pw = ipw;
    
            if (o2.visible == 0)
                return;
            end

            if ishandle(o2.hbar)
                o2.Bval(0);
            else
                ret = -1;
            end
            
        end
        
        function [ret] = Bval(o1, val)

            ret = 1;
    
            if (o1.visible == 0)
                return;
            end

            o2 = o1;
            if ishandle(o2.hbar)
                nval = val/o2.pw;
                if (nval > o2.tval)
                    waitbar(nval, o2.hbar);
                    set(o2.ptch, 'FaceColor', [1 0 0], 'EdgeColor', [1 0 0]);
                elseif (nval < o2.tval)
                    xold = get(o2.ptch, 'XData');
                    xnew = round(100*nval);
                    xt1 = [xnew 100 100 xnew]';
                    xt2 = [0 xnew xnew 0]';
                    set(o2.ptch, 'XData', xt1, 'FaceColor', [1 1 1], 'EdgeColor', [0 0 0]);
                    if (xnew > 0)
                        set(o2.ptch, 'XData', xt2, 'FaceColor', [1 0 0], 'EdgeColor', [1 0 0]);
                    end
                end
                o2.tval = nval;
            else
                ret = -1;
            end
            
        end

        function Bclose(o1)
    
            if (o1.visible == 1)
                if ishandle(o1.hbar)
                    delete(o1.hbar);
                    drawnow;
                end
            end
            
        end
        
    end % methods
    
end % classdef